/*
 * Copyright IBM Corp. and others 1991
 *
 * This program and the accompanying materials are made available under
 * the terms of the Eclipse Public License 2.0 which accompanies this
 * distribution and is available at https://www.eclipse.org/legal/epl-2.0/
 * or the Apache License, Version 2.0 which accompanies this distribution
 * and is available at https://www.apache.org/licenses/LICENSE-2.0.
 *
 * This Source Code may also be made available under the following
 * Secondary Licenses when the conditions for such availability set
 * forth in the Eclipse Public License, v. 2.0 are satisfied: GNU
 * General Public License, version 2 with the GNU Classpath
 * Exception [1] and GNU General Public License, version 2 with the
 * OpenJDK Assembly Exception [2].
 *
 * [1] https://www.gnu.org/software/classpath/license.html
 * [2] https://openjdk.org/legal/assembly-exception.html
 *
 * SPDX-License-Identifier: EPL-2.0 OR Apache-2.0 OR GPL-2.0-only WITH Classpath-exception-2.0 OR GPL-2.0-only WITH OpenJDK-assembly-exception-1.0
 */

/**
 * WARNING!!! GENERATED FILE
 *
 * This class is generated.
 * Do not use the Eclipse "Organize Imports" feature on this class.
 *
 * It can contain user content, but that content must be delimited with the
 * the tags
 * [BEGIN USER IMPORTS]
 * [END USER IMPORTS]
 *
 * or
 *
 * [BEGIN USER CODE]
 * [END USER CODE]
 *
 * These tags are entered as comments.  Characters before [ and after ] are ignored.
 * Lines between the tags are inserted into the newly generated file.
 *
 * IMPORTS are combined and inserted above newly generated imports.  CODE is combined
 * and inserted immediately after the class declaration
 *
 * All lines outside these tags are lost and replaced with newly generated code.
 */
package com.ibm.j9ddr.vm29.pointer.generated;

/*[BEGIN USER IMPORTS]*/
/*[END USER IMPORTS]*/

import com.ibm.j9ddr.CorruptDataException;
import com.ibm.j9ddr.vm29.pointer.*;
import com.ibm.j9ddr.vm29.structure.*;
import com.ibm.j9ddr.vm29.types.*;

/**
 * Structure: MM_SparseHeapLinkedFreeHeaderPointer
 *
 * A generated implementation of a VM structure
 *
 * This class contains generated code and MAY contain hand written user code.
 *
 * Hand written user code must be contained at the top of
 * the class file, specifically above
 * the comment line containing WARNING!!! GENERATED CODE
 *
 * ALL code below the GENERATED warning will be replaced with new generated code
 * each time the PointerGenerator utility is run.
 *
 * The generated code will provide getters for all elements in the MM_SparseHeapLinkedFreeHeaderPointer
 * structure.  Where possible, meaningful return types are inferred.
 *
 * The user may add methods to provide meaningful return types where only pointers
 * could be automatically inferred.
 */
@com.ibm.j9ddr.GeneratedPointerClass(structureClass=MM_SparseHeapLinkedFreeHeader.class)
public class MM_SparseHeapLinkedFreeHeaderPointer extends StructurePointer {

	// NULL
	public static final MM_SparseHeapLinkedFreeHeaderPointer NULL = new MM_SparseHeapLinkedFreeHeaderPointer(0);

/*[BEGIN USER CODE]*/
/*[END USER CODE]*/

	// Do not call this constructor.  Use static method cast instead.
	protected MM_SparseHeapLinkedFreeHeaderPointer(long address) {
		super(address);
	}

	public static MM_SparseHeapLinkedFreeHeaderPointer cast(AbstractPointer structure) {
		return cast(structure.getAddress());
	}

	public static MM_SparseHeapLinkedFreeHeaderPointer cast(UDATA udata) {
		return cast(udata.longValue());
	}

	public static MM_SparseHeapLinkedFreeHeaderPointer cast(long address) {
		if (address == 0) {
			return NULL;
		}
		return new MM_SparseHeapLinkedFreeHeaderPointer(address);
	}

	public MM_SparseHeapLinkedFreeHeaderPointer add(long count) {
		return MM_SparseHeapLinkedFreeHeaderPointer.cast(address + (MM_SparseHeapLinkedFreeHeader.SIZEOF * count));
	}

	public MM_SparseHeapLinkedFreeHeaderPointer add(Scalar count) {
		return add(count.longValue());
	}

	public MM_SparseHeapLinkedFreeHeaderPointer addOffset(long offset) {
		return MM_SparseHeapLinkedFreeHeaderPointer.cast(address + offset);
	}

	public MM_SparseHeapLinkedFreeHeaderPointer addOffset(Scalar offset) {
		return addOffset(offset.longValue());
	}

	public MM_SparseHeapLinkedFreeHeaderPointer sub(long count) {
		return MM_SparseHeapLinkedFreeHeaderPointer.cast(address - (MM_SparseHeapLinkedFreeHeader.SIZEOF * count));
	}

	public MM_SparseHeapLinkedFreeHeaderPointer sub(Scalar count) {
		return sub(count.longValue());
	}

	public MM_SparseHeapLinkedFreeHeaderPointer subOffset(long offset) {
		return MM_SparseHeapLinkedFreeHeaderPointer.cast(address - offset);
	}

	public MM_SparseHeapLinkedFreeHeaderPointer subOffset(Scalar offset) {
		return subOffset(offset.longValue());
	}

	public MM_SparseHeapLinkedFreeHeaderPointer untag(long mask) {
		return MM_SparseHeapLinkedFreeHeaderPointer.cast(address & ~mask);
	}

	public MM_SparseHeapLinkedFreeHeaderPointer untag() {
		return untag(UDATA.SIZEOF - 1);
	}

	protected long sizeOfBaseType() {
		return MM_SparseHeapLinkedFreeHeader.SIZEOF;
	}

	// Implementation methods

	// void* _address
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="__addressOffset_", declaredType="void*")
	public VoidPointer _address() throws CorruptDataException {
		return VoidPointer.cast(getPointerAtOffset(MM_SparseHeapLinkedFreeHeader.__addressOffset_));
	}

	// void* _address
	public PointerPointer _addressEA() throws CorruptDataException {
		return PointerPointer.cast(nonNullFieldEA(MM_SparseHeapLinkedFreeHeader.__addressOffset_));
	}

	// MM_SparseHeapLinkedFreeHeader* _next
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="__nextOffset_", declaredType="MM_SparseHeapLinkedFreeHeader*")
	public MM_SparseHeapLinkedFreeHeaderPointer _next() throws CorruptDataException {
		return MM_SparseHeapLinkedFreeHeaderPointer.cast(getPointerAtOffset(MM_SparseHeapLinkedFreeHeader.__nextOffset_));
	}

	// MM_SparseHeapLinkedFreeHeader* _next
	public PointerPointer _nextEA() throws CorruptDataException {
		return PointerPointer.cast(nonNullFieldEA(MM_SparseHeapLinkedFreeHeader.__nextOffset_));
	}

	// U64 _size
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="__sizeOffset_", declaredType="U64")
	public UDATA _size() throws CorruptDataException {
		return new U64(getLongAtOffset(MM_SparseHeapLinkedFreeHeader.__sizeOffset_));
	}

	// U64 _size
	public UDATAPointer _sizeEA() throws CorruptDataException {
		return UDATAPointer.cast(nonNullFieldEA(MM_SparseHeapLinkedFreeHeader.__sizeOffset_));
	}

}
